#!"\xampp\perl\bin\perl.exe"

# (c) napp-it.org, nov 10, 2024
# autostart.pl

# to debug start via perl ./path/autostart.pl

# this startscript is executed via server.pl on startup as root in the background
# if you want to modify, copy or rename this script to myautostart.pl and edit then

# steps:
# 1. auto mount virtual harddisks .vhdx from c:\vhdx and v:\vhdx when "auto" is in name
# 2. auto zpool import all available pools beside destroyed ones
# 3. auto unlock filesystems when autounlock: is set

# debug only
#require "/xampp/web-gui/data/wwwroot/cgi-bin/admin-wlib.pl";              # common used functions when started from console for debugging

# autostart
my $os = $^O;              # OS
if ($os=~/Win32/i) {       # Windows only
  &my_automount;           # all vhdx with auto in name
  &my_autoimport;          # all importable pools beside destroyed ones
}
&my_autounlock;            # all encrypted ZFS filesystems with autounlock: = yes, all OS

###################
sub my_automount  {
###################

   my @files= glob("c:/vhdx/*auto*.vhdx");  # returns full path
   my @t =    glob("v:/vhdx/*auto*.vhdx");  # returns full path
   push (@files,@t);

   # add smb clusterdisks in \\ip\vhdx\file.vhdx
   my @member=glob("c:/xampp/web-gui/_log/group/cs_*.txt");  # returns full path
   # [0] -> 'c:/xampp/web-gui/_log/group/cs_omni~192.168.2.203.txt'

   my ($r,@cld,@t,$t,@p,$n);
   foreach my $ip (@member) {

      $ip=~s/.*~//;
      $ip=~s/\.txt//;
      #print "$ip\n";

      # get remote files
      # Get-ChildItem -Path \\192.168.2.203\napp-it\* -Filter *.vhdx
      $r=`powershell -command Get-ChildItem -Path //$ip/vhdx/* -Filter *.vhdx`;

      #    Verzeichnis: \\192.168.2.203\vhdx
      # Mode                 LastWriteTime         Length Name
      # ----                 -------------         ------ ----
      # -a----        12.07.2024     10:07      675282944 cs_cluster.vhdx

      if ($r=~/\.vhdx\b/s)     {
          @t=split(/\n/,$r);
          foreach my $t (@t) {
                 if ($t=~/\.vhdx\b/s)     {
                    @p=split(/ +/,$t);
                    if ($p[4]=~/\.vhdx\b/s)     {
                       push (@files,"//$ip/vhdx/$p[4]");
                    }
                 }
          }
      }
   }

   # &print_array(@files);

   # [0] -> 'c:/vhdx/disk4.auto.vhdx'
   # [1] -> 'c:/vhdx/disk5_auto.vhdx'
   # [2] -> 'v:/vhdx/rc_auto.vhdx'
   # [3] -> '//192.168.2.203/vhdx/cs_cluster.vhdx'

   # attach virtual harddisks
   # PS C:\> Mount-VHD -Path c:\test\testvhdx.vhdx
   $n=0;
   foreach my $f (@files) {
        # get-vhd -path c:/vhdx/disk5_auto.vhdx
        # Attached                : False
        $r=`powershell -command Get-VHD -Path $f`;

        if ($r=~/Attached +: False/s) {        # only if not attached
           # print "powershell -command Mount-VHD -Path $f\n";
           $r=`powershell -command Mount-VHD -Path $f`;
           $n++;
        }
   }

   print "automounted $n virtual harddisks\n\n";
}

####################
sub my_autoimport  {
####################
     my (%pools,$k,$t,@t,@p,$r);

     $r=`zpool import`;

     @t=split(/pool: /,$r);
     shift(@t);       # remove first (empty) element
     foreach my $t (@t) { $t=~s/config:.*//s; $t=~s/see:.*//s; }       # remove config

     # [0] -> 'tank
     # id: 139258649720305634
     # state: ONLINE
     # action: The pool can be imported using its name or numeric identifier.
     #'
     # [1] -> 'tank
     # id: 6428117179296904500
     # state: ONLINE
     # action: The pool can be imported using its name or numeric identifier.
     # '
     # [2] -> 'netmirror
     # id: 3437191322604809042
     # state: DEGRADED
     # status: The pool was last accessed by another system.
     # action: The pool can be imported despite missing or damaged devices.  The
     # fault tolerance of the pool may be compromised if imported.

     # import with id
     # if names are not unique, add _ ex tank_

     foreach my $t (@t) {
          @p=split(/\n/,$t);

          # &print_array(@p);
          # [0] -> 'tank'
          # [1] -> '    id: 139258649720305634'
          # [2] -> ' state: ONLINE'
          # opt [3] status:
          # [3] -> 'action: The pool can be imported using its name or numeric identifier.'

          $p[1]=~s/ +id: //;
          $pools{'allid'}.="$p[1],";

          # check for doubles, add _ to name
          while ($pools{'allname'}=~/\b$p[0]\b/)  {
              $p[0].="_";
          }
          $pools{'allname'}.="$p[0],";

          $k=$p[1]."_name";      $pools{$k}=$p[0];
          $k=$p[1]."_id";        $pools{$k}=$p[1];
          $k=$p[1]."_state"; $p[1]=~s/ +state: //; $pools{$k}=$p[2];
          if ($p[3]=~/status:/) {
              $k=$p[1]."_status"; $p[1]=~s/ +status: //; $pools{$k}=$p[3];
          }
          if ($p[3]=~/action:/) {
              $k=$p[1]."_action"; $p[1]=~s/ +action: //; $pools{$k}=$p[3];
          }
          if ($p[4]=~/action:/) {
              $k=$p[1]."_action"; $p[1]=~s/ +action: //; $pools{$k}=$p[4];
          }
     }

     $pools{'allid'}=~s/,$//;
     $pools{'allname'}=~s/,$//;

     #139258649720305634_action ............... -> 'action: The pool can be imported using its name or numeric identifier.'
     #139258649720305634_id ................... -> '139258649720305634'
     #139258649720305634_name ................. -> 'tank'
     #139258649720305634_state ................ -> ' state: ONLINE'
     #3437191322604809042_id .................. -> '3437191322604809042'
     #3437191322604809042_name ................ -> 'netmirror'
     #3437191322604809042_state ............... -> ' state: DEGRADED'
     #3437191322604809042_status .............. -> 'status: The pool was last accessed by another system.'
     #6428117179296904500_action .............. -> 'action: The pool can be imported using its name or numeric identifier.'
     #6428117179296904500_id .................. -> '6428117179296904500'
     #6428117179296904500_name ................ -> 'tank'
     #6428117179296904500_state ............... -> ' state: ONLINE'
     #8445630950825508719_action .............. -> 'action: The pool can be imported using its name or numeric identifier.'
     #8445630950825508719_id .................. -> '8445630950825508719'
     #8445630950825508719_name ................ -> 'z1'
     #8445630950825508719_state ............... -> ' state: ONLINE'
     #allid ................................... -> '139258649720305634,6428117179296904500,3437191322604809042,8445630950825508719'
     #allname ................................. -> 'tank,tank,netmirror,z1'

     # import importable pools
     @t=split(/,/,$pools{'allid'});
     foreach my $t (@t) {
         $k=$t."_action";
         if ($pools{$k}=~/can be imported/) {
             $k=$t."_name";

             print "\nzpool import -f $t $pools{$k}\n";
             `zpool import -f $t $pools{$k}`;
         }
     }

     #print `zpool list`."\n";
     #&print_hash(%pools);
     #&print_array(@t);

}

####################
sub my_autounlock  {
####################
   # autounlock via sub unlock in server.pl
   # as this script is called via server.pl %data is defined as public
   # with last data (member, ip, w1, w2) logged on every unlock to allow autounlock on start

   # must be called via server.pl
   if ($data{'myauth'} eq "") {
     print "\n#################\nautounlock must be called via server.pl\n";
     return;
   }

   print "\n\n##########\nautounlock member $data{'member'}\n##########\n\n";
   my $r=`zfs get -H -t filesystem,volume encryption,keystatus,autounlock:`;      # all ZFS filesystems and volumes

   #tank    encryption      off     default
   #tank    keystatus       -       -
   #tank    autounlock:     -       -
   #tank/enc        encryption      aes-256-gcm     -
   #tank/enc        keystatus       available       -
   #tank/enc        autounlock:     yes     local
   #tank/xx encryption      off     default
   #tank/xx keystatus       -       -
   #tank/xx autounlock:     -       -

   my @l=split(/\n/,$r);

   if (!($l[0]=~/encryption/)) {
        print "\nno filesystem to autounlock\n";
        return;
   }

   # get mwmmber and

   my ($fs,$enc,$status,$unlock,@p);

   while (@l >0)  {
      # encryption
      $enc=shift(@l);  # remove enc from list
      @p=split(/\s+/,$enc);
      $fs=$p[0];
      $enc=$p[2];

      $status=shift(@l);  # remove status from list
      @p=split(/\s+/,$status);
      $status=$p[2];

      $unlock=shift(@l);  # remove unlock from list
      @p=split(/\s+/,$unlock);
      $unlock=$p[2];

      # &unlock unlock::tank/enc::
      # fs ->  tank/enc

      # member is needed as key is like
      # proxmox_1~192.168.2.71~tank~enc.completekey

      # member, ip and pw is loaded in server.pl from $spath/tmp/member.log
      # values in %data from last unlock

      if ($fs=~/\@/)   { next; }         # snap
      print "process $fs $enc $status $unlock\n";

      if (($fs ne "") && ($enc ne "off") && ($status ne "available") && ($unlock eq "yes")) {
         #print "autounlock $fs\n";
         &unlock("unlock::$fs",$data{'ip'});
      }
    }
}

##
1;